Subject: RE: delegation question

From: "Noveck, Dave" <[email-masked]>
Date: Fri, 9 Aug 2002 12:19:39 -0700

> I would suggest that we might pause and think about this issue before
> making a last minute change.  

But after we pause, what do we decide to do?

> > My comments are inline.
> 
> On Fri, Noveck, Dave wrote:
> > It seems to me that this is a worthwhile thing to do.  
>
> Maybe but I think the a solution may be move invasive.

I know.

> > How about adding to the implementation section of RENEW:
> > 
> >     If there are outstanding delegation recalls, a server
> >     may return NFS4ERR_RESOURCE to indicate the potential
> >     for delegation revocation to the client.  The client,
> >     in this case, should return his delegations, to forstall
> >     delegation revocation when, for some reason, there are
> >     problems receiving callbacks.  The server MAY still 
> >     renew the lease, even when returning NFS4ERR_RESOURCE.
>
> What about those clients that don't send RENEW because their lease is
> being renewed because of other activity that does not deal with the
> delegated file in question.  It seems like a solution would need to
> define a new error NFS4ERR_DELEGATION_REVOKED and that error would
> then be valid for RENEW and every operation that uses a piece of state
> (clientid, stateid).  The client would then have to be able to return
> the delegations as you suggest and then restart the operation in
> question.  Not sure I am for this type of change at this point.

I odn't think I would be either.  The question is whether a partial
solution is better than none at this point.

> > By the way, there are errors for RENEW that don't seem right.
> > Since RENEW does not require a filehandle, NFS4ERR_MOVED and
> > NFS4ERR_WRONGSEC, don't seem as if they should be there.  Also, 
>
> NFS4ERR_MOVED is there if the fileserver has migrated a filesystem
> that the client has state on and the client has yet to be notified of
> the migration (this notification is very similar to the discussion above.

That is NFS4ERR_LEASE_MOVED (which is also in the list).  That says that
some filesystem for whcih you have locks has moved and the client needs
to find out which one.  NFS4ERR_MOVED says that the current filesystem 
has moved and the client needs to find out where.  Since there is no
current fh and thus no current fs for RENEW, I don't think you can get
NFS4ERR_MOVED.

> I have already remove WRONGSEC from the error list (in the version to
> come).

> > I have doubts about NFS4ERR_GRACE.  If I reclaimed a lock during 
> > the grace period, I have a lease, so why shouldn't I be allowed 
> > to renew it early, since it is desirable for me to make sure that 
> > it gets done in good time.
>
> Yes. This doesn't seem appropriate.

---

From: Spencer Shepler <[email-masked]>
Date: Fri, 9 Aug 2002 15:20:30 -0500

> But after we pause, what do we decide to do?

Well, I was speaking in terms of hours so a decision during WG last
call is acceptable to me and yes, we do have to make a decision. :-)

> current fh and thus no current fs for RENEW, I don't think you can get

My mistake.  I will remove NFS4ERR_MOVED from RENEW.

-- 
Spencer